import javax.script.*;
import java.io.FileReader;
import org.rexxla.bsf.engines.rexx.jsr223.*;

public class Test_03 	// demo evaluating a Rexx script
{
    public static void main (String args[])
    {
        ScriptEngineManager manager = new ScriptEngineManager();
        ScriptEngine            rse = manager.getEngineByName("Rexx");
        try
        {
	    String filename="test_rexx_03.rex";      // define the filename
		// add the filename to the engine's SimpleBindings
            ScriptContext sc=rse.getContext();  // get the default ScriptContext
            sc.setAttribute(ScriptEngine.FILENAME,filename,ScriptContext.ENGINE_SCOPE);
            sc.setAttribute("d1",  "1", ScriptContext.GLOBAL_SCOPE);
            sc.setAttribute("d2",  "2", ScriptContext.GLOBAL_SCOPE);
            sc.setAttribute("sum", "3", ScriptContext.GLOBAL_SCOPE);
            showAttributes(sc);
            rse.eval(new FileReader(filename), sc);  // now let us execute the Rexx script

            System.out.println("\n... about to call public Rexx routine 'one':");
            // now let us execute a global Rexx routine, forward slotDir argument!
            rse.eval("call one arg(arg())");
            showAttributes(sc);

            System.out.println("\n... about to call public Rexx routine 'two':");
            // now let us execute a global Rexx routine, forward slotDir argument!
            rse.eval("call two arg(arg())");
            showAttributes(sc);
        }
        catch (Exception exc)
        {
            System.err.println(exc);
            System.exit(-1);
        }
    }
    public static void showAttributes(ScriptContext sc)
    {
        System.out.println("... d1=["+sc.getAttribute("d1")+"]"
                           + ", d2=["+sc.getAttribute("d2")+"]"
                          + ", sum=["+sc.getAttribute("sum")+"] ...");
    }

}

